"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _core = require("@emotion/core");

var _reactSyntaxHighlighter = require("react-syntax-highlighter");

var _components = require("@atlaskit/theme/components");

var _useHighlight = require("./internal/hooks/use-highlight");

var _styles = require("./internal/theme/styles");

var _getNormalizedLanguage = require("./internal/utils/get-normalized-language");

/** @jsx jsx */
var CodeBlock = /*#__PURE__*/(0, _react.memo)(function CodeBlock(_ref) {
  var _ref$showLineNumbers = _ref.showLineNumbers,
      showLineNumbers = _ref$showLineNumbers === void 0 ? true : _ref$showLineNumbers,
      _ref$language = _ref.language,
      providedLanguage = _ref$language === void 0 ? 'text' : _ref$language,
      _ref$highlight = _ref.highlight,
      highlight = _ref$highlight === void 0 ? '' : _ref$highlight,
      _ref$highlightedStart = _ref.highlightedStartText,
      highlightedStartText = _ref$highlightedStart === void 0 ? 'Highlight start' : _ref$highlightedStart,
      _ref$highlightedEndTe = _ref.highlightedEndText,
      highlightedEndText = _ref$highlightedEndTe === void 0 ? 'Highlight end' : _ref$highlightedEndTe,
      testId = _ref.testId,
      text = _ref.text;
  var numLines = (text || '').split('\n').length;
  var globalTheme = (0, _components.useGlobalTheme)();
  var theme = (0, _react.useMemo)(function () {
    return (0, _styles.getCodeBlockTheme)(globalTheme, numLines);
  }, [globalTheme, numLines]);
  var getStyles = (0, _react.useMemo)(function () {
    return (0, _styles.getCodeBlockStyles)(theme);
  }, [theme]);
  var styles = (0, _react.useMemo)(function () {
    return getStyles(highlightedStartText, highlightedEndText, showLineNumbers);
  }, [highlightedStartText, highlightedEndText, showLineNumbers, getStyles]);

  var _useHighlightLines = (0, _useHighlight.useHighlightLines)({
    highlight: highlight,
    testId: testId
  }),
      getHighlightStyles = _useHighlightLines.getHighlightStyles,
      highlightedLines = _useHighlightLines.highlightedLines;

  var getLineProps = (0, _react.useCallback)(function (line) {
    return getHighlightStyles(line, highlightedLines);
  }, [getHighlightStyles, highlightedLines]);
  var language = (0, _react.useMemo)(function () {
    return (0, _getNormalizedLanguage.normalizeLanguage)(providedLanguage);
  }, [providedLanguage]); // https://product-fabric.atlassian.net/browse/DST-2472

  var languageToUse = text ? language : 'text';
  return (0, _core.jsx)(_reactSyntaxHighlighter.PrismAsync, {
    "data-testid": testId,
    "data-code-lang": language,
    "data-ds--code--code-block": "",
    css: styles,
    language: languageToUse,
    PreTag: "span",
    showLineNumbers: showLineNumbers // Wrap lines is needed to set styles on the line when highlighting.
    ,
    wrapLines: highlight.length > 0 || !!testId,
    lineProps: getLineProps,
    useInlineStyles: false
  }, text);
});
CodeBlock.displayName = 'CodeBlock';
var _default = CodeBlock;
exports.default = _default;