import _extends from "@babel/runtime/helpers/extends";

/** @jsx jsx */
import { forwardRef, memo, useMemo } from 'react';
import { jsx } from '@emotion/core';
import { useGlobalTheme } from '@atlaskit/theme/components';
import { getCodeStyles } from './internal/theme/styles';
const Code = /*#__PURE__*/memo( /*#__PURE__*/forwardRef(function Code({
  testId,
  ...props
}, ref) {
  const theme = useGlobalTheme();
  const styles = useMemo(() => getCodeStyles(theme), [theme]);
  return jsx("code", _extends({
    ref: ref,
    "data-testid": testId,
    css: styles
  }, props));
}));
Code.displayName = 'Code';
export { getCodeStyles };
export default Code;