import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

/** @jsx jsx */
import { forwardRef, memo, useMemo } from 'react';
import { jsx } from '@emotion/core';
import { useGlobalTheme } from '@atlaskit/theme/components';
import { getCodeStyles } from './internal/theme/styles';
var Code = /*#__PURE__*/memo( /*#__PURE__*/forwardRef(function Code(_ref, ref) {
  var testId = _ref.testId,
      props = _objectWithoutProperties(_ref, ["testId"]);

  var theme = useGlobalTheme();
  var styles = useMemo(function () {
    return getCodeStyles(theme);
  }, [theme]);
  return jsx("code", _extends({
    ref: ref,
    "data-testid": testId,
    css: styles
  }, props));
}));
Code.displayName = 'Code';
export { getCodeStyles };
export default Code;