import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import memoizeOne from 'memoize-one';
import * as colors from '@atlaskit/theme/colors';
import { themed } from '@atlaskit/theme/components';
import { codeFontFamily } from '@atlaskit/theme/constants';
// Hardcoded values have been used due to the current color palette not having any
// accessible color options for Teal and Yellow and +20A
var T800 = '#067384';
var Y1100 = '#7A5D1A';
var PLUS20 = '#3A434E';
export var getBaseTheme = function getBaseTheme(theme) {
  return {
    fontFamily: codeFontFamily(),
    fontFamilyItalic: "SFMono-MediumItalic, ".concat(codeFontFamily()),
    backgroundColor: themed({
      light: colors.N20,
      dark: colors.DN50
    })({
      theme: theme
    }),
    textColor: themed({
      light: colors.N800,
      dark: colors.DN800
    })({
      theme: theme
    }),
    lineNumberColor: themed({
      light: colors.N400,
      dark: colors.DN400
    })({
      theme: theme
    }),
    lineNumberBgColor: themed({
      light: colors.N30,
      dark: colors.DN20
    })({
      theme: theme
    })
  };
};
export var defaultBaseTheme = getBaseTheme({
  mode: 'light'
});
export var getColorPalette = memoizeOne(function (theme) {
  var akTheme = {
    theme: theme
  };
  return {
    highlightedLineBgColor: themed({
      light: colors.N30,
      dark: PLUS20
    })(akTheme),
    highlightedLineBorderColor: themed({
      light: colors.B200,
      dark: colors.B100
    })(akTheme),
    substringColor: themed({
      light: colors.N400,
      dark: colors.DN400
    })(akTheme),
    keywordColor: themed({
      light: colors.B400,
      dark: colors.B75
    })(akTheme),
    attributeColor: themed({
      light: T800,
      dark: colors.T200
    })(akTheme),
    selectorTagColor: themed({
      light: colors.B400,
      dark: colors.B75
    })(akTheme),
    docTagColor: themed({
      light: Y1100,
      dark: colors.Y300
    })(akTheme),
    nameColor: themed({
      light: colors.B400,
      dark: colors.B75
    })(akTheme),
    builtInColor: themed({
      light: colors.B400,
      dark: colors.B75
    })(akTheme),
    literalColor: themed({
      light: colors.B400,
      dark: colors.B75
    })(akTheme),
    bulletColor: themed({
      light: colors.B400,
      dark: colors.B75
    })(akTheme),
    codeColor: themed({
      light: colors.B400,
      dark: colors.B75
    })(akTheme),
    regexpColor: themed({
      light: T800,
      dark: colors.T200
    })(akTheme),
    symbolColor: themed({
      light: T800,
      dark: colors.T200
    })(akTheme),
    variableColor: themed({
      light: T800,
      dark: colors.T200
    })(akTheme),
    templateVariableColor: themed({
      light: T800,
      dark: colors.T200
    })(akTheme),
    linkColor: themed({
      light: colors.P300,
      dark: colors.P75
    })(akTheme),
    selectorAttributeColor: themed({
      light: T800,
      dark: colors.T200
    })(akTheme),
    selectorPseudoColor: themed({
      light: T800,
      dark: colors.T200
    })(akTheme),
    typeColor: themed({
      light: T800,
      dark: colors.T100
    })(akTheme),
    stringColor: themed({
      light: colors.G500,
      dark: colors.G200
    })(akTheme),
    selectorIdColor: themed({
      light: T800,
      dark: colors.T100
    })(akTheme),
    selectorClassColor: themed({
      light: T800,
      dark: colors.T100
    })(akTheme),
    quoteColor: themed({
      light: T800,
      dark: colors.T100
    })(akTheme),
    templateTagColor: themed({
      light: T800,
      dark: colors.T100
    })(akTheme),
    titleColor: themed({
      light: colors.P300,
      dark: colors.P75
    })(akTheme),
    sectionColor: themed({
      light: colors.P300,
      dark: colors.P75
    })(akTheme),
    commentColor: themed({
      light: colors.N400,
      dark: colors.DN400
    })(akTheme),
    metaKeywordColor: themed({
      light: colors.G500,
      dark: colors.G200
    })(akTheme),
    metaColor: themed({
      light: colors.N400,
      dark: colors.DN400
    })(akTheme),
    functionColor: themed({
      light: colors.N800,
      dark: colors.DN800
    })(akTheme),
    numberColor: themed({
      light: colors.B400,
      dark: colors.B75
    })(akTheme),
    prologColor: themed({
      light: colors.B400,
      dark: colors.B75
    })(akTheme),
    cdataColor: themed({
      light: colors.N400,
      dark: colors.B75
    })(akTheme),
    punctuationColor: themed({
      light: colors.N800,
      dark: colors.DN800
    })(akTheme),
    propertyColor: themed({
      light: colors.P300,
      dark: colors.P75
    })(akTheme),
    constantColor: themed({
      light: T800,
      dark: colors.T100
    })(akTheme),
    booleanColor: themed({
      light: colors.B500,
      dark: colors.B75
    })(akTheme),
    charColor: themed({
      light: colors.N800,
      dark: colors.DN800
    })(akTheme),
    insertedColor: themed({
      light: colors.G500,
      dark: colors.B75
    })(akTheme),
    deletedColor: themed({
      light: colors.R500,
      dark: colors.B75
    })(akTheme),
    operatorColor: themed({
      light: colors.N800,
      dark: colors.B75
    })(akTheme),
    atruleColor: themed({
      light: colors.G500,
      dark: colors.G200
    })(akTheme),
    importantColor: themed({
      light: Y1100,
      dark: colors.Y300
    })(akTheme)
  };
});

var getTheme = function getTheme(theme) {
  return _objectSpread(_objectSpread({}, getBaseTheme(theme)), getColorPalette(theme));
};

export default getTheme;