import type { CSSObject } from '@emotion/core';
import type { Theme } from '@atlaskit/theme/types';
import type { CodeBlockTheme, CodeTheme } from './types';
export declare const getLineNumWidth: (numLines: number) => string;
/**
 * Styles applied at the root element level, common across code/codeblock
 */
export declare const getBaseCodeStyles: (theme: CodeTheme) => CSSObject;
/**
 * Takes an implemented CodeBlock theme, and returns styles required for
 * react-syntax-highlighter.
 *
 * @param theme
 */
export declare const getCodeBlockStyles: (theme: CodeBlockTheme) => (highlightedStartText: string, highlightedEndText: string, hasLineNumbers?: boolean | undefined) => CSSObject;
export declare const getCodeStyles: (globalTheme: Theme) => CSSObject;
export declare const getCodeBlockTheme: (globalTheme: Theme, maxLines?: number | undefined) => CodeBlockTheme;
